// intellectual property is bullshit bgdc

#include "utask.h"

#include <stdbool.h>
#include <stddef.h>
#include <inttypes.h>
#include <stdatomic.h>

utask_t * current_task;
utask_t * volatile task_list;

static atomic_uint _sleep_inh;

UTASK_ARCH_SPECIFIC_DEFS

static void _init_stack(utask_t * task);

static const uint8_t _canary[4] = {
	(UTASK_STACK_CANARY) & 0xFF,
	(UTASK_STACK_CANARY >> 8) & 0xFF,
	(UTASK_STACK_CANARY >> 16) & 0xFF,
	(UTASK_STACK_CANARY >> 24) & 0xFF,
};

void utask_add(utask_t * task, uintptr_t arg)
{
	task->_next = task_list;
	task->_started = false;
	task->_arg = arg;
	task_list = task;
}

void utask_run(void)
{
	for (;;)
	{
		for (utask_t * task = task_list; task; task = task->_next)
		{
			current_task = task;

			if (task->_started)
			{
				utask_continue(task);
			}
			else
			{
				task->_started = true;
				_init_stack(task);
				utask_start(task);
			}

			if (task->stack[0] != _canary[0]
			 || task->stack[1] != _canary[1]
			 || task->stack[2] != _canary[2]
			 || task->stack[3] != _canary[3])
				utask_stack_overflow_cb(task);
		}

		if (!_sleep_inh)
			utask_sleep_cb();
	}
}

void utask_sleep_inhibit(void)
{
	atomic_fetch_add(&_sleep_inh, 1);
}

void utask_sleep_allow(void)
{
	atomic_fetch_sub(&_sleep_inh, 1);
}

__attribute__((weak))
void utask_stack_overflow_cb(utask_t * task)
{
	(void) task;
	for (;;);
}

__attribute__((weak))
void utask_sleep_cb(void)
{
}

size_t utask_stack_free_bytes(utask_t * task)
{
	for (size_t i = 0; i < task->stack_size; i++)
	{
		if (task->stack[i] != _canary[i & 3])
			return i;
	}

	return task->stack_size;
}

static void _init_stack(utask_t * task)
{
	task->stack_size = utask_fixup_stack_len(task->stack_size);

	for (size_t i = 0; i < task->stack_size; i++)
	{
		task->stack[i] = _canary[i & 3];
	}
}
